<div>
    <div class="light-border-spacing">
        <div class="title-spinner">
            <h4 class="title-bc">
                LATEST BLOCKS DETAILS
                <b-spinner v-if="blocks_details===undefined" class="spaced-spinner"></b-spinner>
            </h4>
            <br />
        </div>
        <table class="table table-responsive w-100 d-block table-striped table-hover">
            <thead>
                <tr>
                    <th scope="col" style="width: 5%">Level</th>
                    <th scope="col" style="width: 5%">Round</th>
                    <th scope="col" style="width: 5%">Hash</th>
                    <th scope="col" style="width: 5%"><p id="mob">MO/B</p></th>
                    <th scope="col" style="width: 5%"><p id="baker-rew">BK&Rew</p></th>
                    <th scope="col" style="width: 5%"><p id="prop-rew">Prop&Rew</p></th>
                    <th scope="col" style="width: 5%"><p id="e-pow">A.Power</p></th>
                    <th
                        v-if="blocks_details!=undefined&&blocks_details[0].dal_attestation!=undefined"
                        scope="col"
                        style="width: 5%"
                    >
                        <p id="dal">DAL</p>
                    </th>
                    <th scope="col" style="width: 5%"><p id="m-slots">M.Slots</p></th>
                    <th class="lb-min-width-1" scope="col" style="width: 10%">Timestamp</th>
                    <th class="lb-min-width-2" scope="col" style="width: 20%">Who's missing ?</th>
                    <th class="lb-min-width-3" scope="col" style="width: 30%">
                        <p id="fitness">Fitness</p>
                    </th>
                    <b-tooltip
                        v-if="blocks_details!=undefined&&blocks_details[0].dal_attestation!=undefined"
                        target="dal"
                        placement="top"
                        boundary="window"
                        triggers="hover"
                    >
                        <p class="text-nowrap">Number of attested DAL slots</p>
                    </b-tooltip>
                    <b-tooltip target="mob" placement="top" boundary="window" triggers="hover">
                        <p class="text-nowrap">Monitor operations / Batches</p>
                    </b-tooltip>
                    <b-tooltip
                        target="baker-rew"
                        placement="top"
                        boundary="window"
                        triggers="hover"
                    >
                        <p class="text-nowrap">Baker and his/her ꜩ reward</p>
                    </b-tooltip>
                    <b-tooltip target="prop-rew" placement="top" boundary="window" triggers="hover">
                        <p class="text-nowrap">Proposer and his/her ꜩ reward</p>
                    </b-tooltip>
                    <b-tooltip target="e-pow" placement="top" boundary="window" triggers="hover">
                        <p>Attestation power</p>
                    </b-tooltip>
                    <b-tooltip target="m-slots" placement="top" boundary="window" triggers="hover">
                        <p>Missed slots</p>
                    </b-tooltip>
                    <b-tooltip target="fitness" placement="top" boundary="window" triggers="hover">
                        <p>
                            <a
                                href="https://hal.archives-ouvertes.fr/hal-03398884/document#page=7"
                                target="_blank"
                                >Click here to get more information about Fitness —
                                <i>see The Mempool</i></a
                            >
                        </p>
                    </b-tooltip>
                </tr>
            </thead>
            <tbody v-if="blocks_details!=undefined">
                <tr v-for="block_details in blocks_details">
                    <td v-if="protocol_transition_level===block_details.level">
                        {{ block_details.level }}
                        <i id="lb-protocol-injection-level" class="bi bi-globe2"></i>
                        <b-tooltip target="lb-protocol-injection-level" placement="top">
                            <p class="center-text text-nowrap">Protocol injection level</p>
                        </b-tooltip>
                    </td>
                    <td v-else>{{ block_details.level }}</td>
                    <td>{{ block_details.round }}</td>
                    <td><v-hash v-bind:hash="block_details.hash" category="hash"></v-hash></td>
                    <td>{{ block_details.manager_ops }}/{{ block_details.manager_ops_batches }}</td>
                    <td>
                        <v-hash
                            v-bind:hash="block_details.baker"
                            category="account"
                            class="text-nowrap"
                        ></v-hash>
                        <span>[{{ block_details.baker_rew }}]</span>
                    </td>
                    <td>
                        <v-hash
                            v-bind:hash="block_details.proposer"
                            category="account"
                            class="text-nowrap"
                        ></v-hash>
                        <span>[{{ block_details.proposer_rew }}]</span>
                    </td>
                    <td>{{ block_details.attestation_power }}%</td>
                    <td v-if="block_details.dal_attestation!=undefined">
                        {{ block_details.dal_attestation }}
                    </td>
                    <td>{{ block_details.missed_slots }}</td>
                    <td>
                        {{ block_details.timestamp.time }}<br />
                        {{ block_details.timestamp.date }}
                    </td>
                    <td>
                        <ul class="no-margin-padding inline-block-ul">
                            <li v-for="miss in block_details.missing_attesters">
                                <v-hash
                                    v-bind:hash="miss.attester"
                                    category="account"
                                    class="text-nowrap"
                                    v-slot="{ shorten_hash }"
                                >
                                    {{ shorten_hash }}[{{ miss.slots }}]
                                </v-hash>
                            </li>
                        </ul>
                    </td>
                    <td v-if="block_details.fitness.Genesis!=undefined">Genesis</td>
                    <td v-if="(block_details.fitness.Emmy!=undefined)&&(block_details.level===1)">
                        Injection protocol block
                    </td>
                    <td v-if="block_details.fitness.Tenderbake!=undefined">
                        <span :id="'fitness_level' + block_details.level">
                            {{ block_details.fitness.Tenderbake.current_level_hexa.hex }}
                        </span>
                        <span>|</span>
                        <span :id="'fitness_prev_round_pqc' + block_details.level">
                            <span
                                v-if="block_details.fitness.Tenderbake.previous_round_of_pqc!=undefined"
                            >
                                {{ block_details.fitness.Tenderbake.previous_round_of_pqc.hex }}
                            </span>
                            <span v-else> ε </span>
                        </span>
                        <span>|</span>
                        <span :id="'fitness_prev_round' + block_details.level">
                            {{ block_details.fitness.Tenderbake.minus_previous_round.hex }}
                        </span>
                        <span>|</span>
                        <span :id="'fitness_round' + block_details.level">
                            {{ block_details.fitness.Tenderbake.current_round.hex }}
                        </span>
                        <b-tooltip :target="'fitness_level' + block_details.level" triggers="hover">
                            {{ block_details.fitness.Tenderbake.current_level_hexa.dec }}
                        </b-tooltip>
                        <b-tooltip
                            :target="'fitness_prev_round_pqc' + block_details.level"
                            triggers="hover"
                        >
                            <span
                                v-if="block_details.fitness.Tenderbake.previous_round_of_pqc!=undefined"
                            >
                                {{ block_details.fitness.Tenderbake.previous_round_of_pqc.dec }}
                            </span>
                            <span v-else> 0 </span>
                        </b-tooltip>
                        <b-tooltip
                            :target="'fitness_prev_round' + block_details.level"
                            triggers="hover"
                        >
                            {{ block_details.fitness.Tenderbake.minus_previous_round.dec }}
                        </b-tooltip>
                        <b-tooltip :target="'fitness_round' + block_details.level" triggers="hover">
                            {{ block_details.fitness.Tenderbake.current_round.dec }}
                        </b-tooltip>
                    </td>
                </tr>
            </tbody>
            <tbody v-else>
                <tr v-for="i in 8">
                    <td v-for="i in 11" style="height: 150px"></td>
                </tr>
            </tbody>
        </table>
    </div>
</div>
